﻿// <auto-generated />
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using SwedenIntroToEF.DataAccess;

#nullable disable

namespace SwedenIntroToEF.Migrations
{
    [DbContext(typeof(PostGradDbContext))]
    [Migration("20230815095846_CorrectedProfQualRelationship")]
    partial class CorrectedProfQualRelationship
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "7.0.10")
                .HasAnnotation("Relational:MaxIdentifierLength", 128);

            SqlServerModelBuilderExtensions.UseIdentityColumns(modelBuilder);

            modelBuilder.Entity("SwedenIntroToEF.Models.Professor", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<string>("FirstName")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.Property<string>("LastName")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.Property<string>("Subject")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.HasKey("Id");

                    b.ToTable("Professors");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            FirstName = "Warren",
                            LastName = "West",
                            Subject = "JavaScript"
                        },
                        new
                        {
                            Id = 2,
                            FirstName = "Dean",
                            LastName = "von Schoultz",
                            Subject = "C#"
                        },
                        new
                        {
                            Id = 3,
                            FirstName = "Reza",
                            LastName = "Mirzaei",
                            Subject = "Java"
                        });
                });

            modelBuilder.Entity("SwedenIntroToEF.Models.ProfessorQualification", b =>
                {
                    b.Property<int>("ProfessorId")
                        .HasColumnType("int");

                    b.Property<int>("QualificationId")
                        .HasColumnType("int");

                    b.Property<string>("YearEarned")
                        .IsRequired()
                        .HasMaxLength(4)
                        .HasColumnType("nvarchar(4)");

                    b.HasKey("ProfessorId", "QualificationId");

                    b.HasIndex("QualificationId");

                    b.ToTable("ProfessorQualifications");

                    b.HasData(
                        new
                        {
                            ProfessorId = 1,
                            QualificationId = 1,
                            YearEarned = "2015"
                        },
                        new
                        {
                            ProfessorId = 2,
                            QualificationId = 1,
                            YearEarned = "2014"
                        },
                        new
                        {
                            ProfessorId = 2,
                            QualificationId = 2,
                            YearEarned = "2020"
                        },
                        new
                        {
                            ProfessorId = 2,
                            QualificationId = 3,
                            YearEarned = "2023"
                        },
                        new
                        {
                            ProfessorId = 3,
                            QualificationId = 4,
                            YearEarned = "2012"
                        },
                        new
                        {
                            ProfessorId = 3,
                            QualificationId = 5,
                            YearEarned = "2016"
                        });
                });

            modelBuilder.Entity("SwedenIntroToEF.Models.Qualification", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("nvarchar(100)");

                    b.HasKey("Id");

                    b.ToTable("Qualifications");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            Name = "BTech Information Technology"
                        },
                        new
                        {
                            Id = 2,
                            Name = "Masters in Information Technology"
                        },
                        new
                        {
                            Id = 3,
                            Name = "PhD in Information Technology"
                        },
                        new
                        {
                            Id = 4,
                            Name = "BSc in Computer Science"
                        },
                        new
                        {
                            Id = 5,
                            Name = "Masters in Computer Science"
                        });
                });

            modelBuilder.Entity("SwedenIntroToEF.Models.Student", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<string>("FirstName")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("LastName")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<int>("ProfessorId")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("ProfessorId");

                    b.ToTable("Students");
                });

            modelBuilder.Entity("SwedenIntroToEF.Models.ProfessorQualification", b =>
                {
                    b.HasOne("SwedenIntroToEF.Models.Professor", "Professor")
                        .WithMany("ProfessorQualifications")
                        .HasForeignKey("ProfessorId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("SwedenIntroToEF.Models.Qualification", "Qualification")
                        .WithMany("ProfessorQualifications")
                        .HasForeignKey("QualificationId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Professor");

                    b.Navigation("Qualification");
                });

            modelBuilder.Entity("SwedenIntroToEF.Models.Student", b =>
                {
                    b.HasOne("SwedenIntroToEF.Models.Professor", "Professor")
                        .WithMany()
                        .HasForeignKey("ProfessorId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Professor");
                });

            modelBuilder.Entity("SwedenIntroToEF.Models.Professor", b =>
                {
                    b.Navigation("ProfessorQualifications");
                });

            modelBuilder.Entity("SwedenIntroToEF.Models.Qualification", b =>
                {
                    b.Navigation("ProfessorQualifications");
                });
#pragma warning restore 612, 618
        }
    }
}
